/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

package net.lensfrex.dscape.cache;

import net.lensfrex.dscape.configure.GlobalConstant;
import net.lensfrex.dscape.dao.entity.UserBasic;
import net.lensfrex.dscape.utils.ObjectJsonSerializer;
import lombok.extern.slf4j.Slf4j;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class UserBasicCache {

    private static final String USER_INFO_CACHE_KEY = GlobalConstant.USER_INFO_CACHE_KEY;

    private static final String USERNAME_UID_CACHE_KEY = GlobalConstant.USERNAME_UID_CACHE_KEY;

    private final RedisTemplate<String, String> redis;

    public UserBasicCache(RedisTemplate<String, String> redis) {
        this.redis = redis;
    }

    public UserBasic getUserByUid(String uid) {
        try {
            String cacheData = (String) redis.opsForHash().get(USER_INFO_CACHE_KEY, uid);
            if (cacheData != null) {
                return ObjectJsonSerializer.deserialize(cacheData, UserBasic.class);
            } else {
                log.debug("缓存中没有用户信息");
                return null;
            }
        } catch (Exception e) {
            log.warn("获取缓存时出现问题");
            log.debug("追踪：", e);
            return null;
        }
    }

    public UserBasic getUserByUserName(String username) {
        try {
            String uid = (String) redis.opsForHash().get(USERNAME_UID_CACHE_KEY, username);
            if (uid != null) {
                return this.getUserByUid(uid);
            } else {
                log.debug("缓存中没有用户名和uid的对应信息");
                return null;
            }
        } catch (Exception e) {
            log.warn("获取缓存时出现问题");
            log.debug("追踪：", e);
            return null;
        }
    }

    public void save(UserBasic userBasic) {
        redis.opsForHash().put(USER_INFO_CACHE_KEY, userBasic.getUid(), ObjectJsonSerializer.serialize(userBasic));
        redis.opsForHash().put(USERNAME_UID_CACHE_KEY, userBasic.getUserName(), userBasic.getUid());
    }

    public void clear(String uid) {
        redis.opsForHash().delete(USER_INFO_CACHE_KEY, uid);
    }
}
