/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

package net.lensfrex.dscape.dao.configure;

import com.baomidou.mybatisplus.annotation.DbType;
import com.baomidou.mybatisplus.extension.plugins.MybatisPlusInterceptor;
import com.baomidou.mybatisplus.extension.plugins.inner.PaginationInnerInterceptor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.autoconfigure.jdbc.DataSourceProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.transaction.annotation.EnableTransactionManagement;

import javax.annotation.Resource;

/**
 * 分页功能的配置类
 */
@Slf4j
@Configuration
@EnableTransactionManagement
public class MybatisPlusConfigure {
    @Resource
    DataSourceProperties dataSourceProperties;

    @Bean
    public PaginationInnerInterceptor paginationInnerInterceptor() {
        return new PaginationInnerInterceptor();
    }

    @Bean
    public MybatisPlusInterceptor mybatisPlusInterceptor() {
        MybatisPlusInterceptor interceptor = new MybatisPlusInterceptor();
        String databaseDriverName = dataSourceProperties.getDriverClassName();

        PaginationInnerInterceptor paginationInnerInterceptor;
        if (databaseDriverName.contains("mariadb")) {
            log.info("使用Mariadb作为数据库");
            paginationInnerInterceptor = new PaginationInnerInterceptor(DbType.MARIADB);
        } else if (databaseDriverName.contains("mysql")) {
            log.info("使用Mysql作为数据库");
            paginationInnerInterceptor = new PaginationInnerInterceptor(DbType.MYSQL);
        } else {
            paginationInnerInterceptor = new PaginationInnerInterceptor();
            log.warn("使用了可能不受支持的数据库：" + databaseDriverName);
        }
        paginationInnerInterceptor.setOptimizeJoin(true);

        interceptor.addInnerInterceptor(paginationInnerInterceptor);
        return interceptor;
    }

}
