/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

package net.lensfrex.dscape.web.controllers.history;

import cn.dev33.satoken.annotation.SaCheckLogin;
import cn.dev33.satoken.stp.StpUtil;
import net.lensfrex.dscape.dao.entity.PatientData;
import net.lensfrex.dscape.dto.response.data.compute.ComputeHistoryResponseData;
import net.lensfrex.dscape.dto.response.general.Response;
import net.lensfrex.dscape.dto.response.general.ResponseCode;
import net.lensfrex.dscape.exception.GlobalException;
import net.lensfrex.dscape.web.service.data.HistoryService;
import org.springframework.web.bind.annotation.*;

import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.List;

@SaCheckLogin
@RestController
@RequestMapping("/history")
public class HistoryController {
    private final HistoryService historyService;

    public HistoryController(HistoryService historyService) {
        this.historyService = historyService;
    }

    @GetMapping(value = "/list", produces = "application/json")
    public Response<List<ComputeHistoryResponseData>> list(@RequestParam(required = false, defaultValue = "1") int page,
                                                           @RequestParam(required = false, defaultValue = "10") int limit) {

        String uid = StpUtil.getLoginIdAsString();

        List<PatientData> results = historyService.getUserHistoryData(uid, page, limit);

        List<ComputeHistoryResponseData> responseDataList = new ArrayList<>(results.size());
        results.forEach(result -> {
            ComputeHistoryResponseData response = new ComputeHistoryResponseData();
            response.setId(result.getId());
            response.setPid(result.getPid());
            response.setCpg(result.getCpg());
            response.setHcc(result.getIsHcc() == 1);
            response.setHccInfer(result.getIsInferHcc() == 1);
            response.setCtdna(result.getCtdnaLength());
            response.setTime(result.getCreateTime().format(DateTimeFormatter.ISO_LOCAL_DATE_TIME));

            responseDataList.add(response);
        });

        return Response.success(responseDataList);
    }

    @RequestMapping(value = "/delete/{rid}", method = {RequestMethod.DELETE, RequestMethod.GET}, produces = "application/json")
    public Response<Object> delete(@PathVariable long rid) {
        String historyUser = historyService.getHistoryUser(rid);

        if (!StpUtil.getLoginIdAsString().equals(historyUser)) {
            throw new GlobalException(ResponseCode.PERMISSION_DENIED);
        }

        historyService.deleteHistoryData(rid);

        return Response.success();
    }

    @RequestMapping(value = "/count", method = {RequestMethod.DELETE, RequestMethod.GET}, produces = "application/json")
    public Response<Long> count() {
        long result = historyService.getTotalCount(StpUtil.getLoginIdAsString());

        return Response.success(result);
    }
}
