/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

package net.lensfrex.dscape.web.controllers.user;

import cn.dev33.satoken.stp.SaTokenInfo;
import cn.dev33.satoken.stp.StpUtil;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import net.lensfrex.dscape.dto.request.UserLoginRequestBody;
import net.lensfrex.dscape.dto.response.general.Response;
import net.lensfrex.dscape.dto.response.general.ResponseCode;
import net.lensfrex.dscape.exception.GlobalException;
import net.lensfrex.dscape.web.service.user.UserService;
import net.lensfrex.dscape.dto.request.user.PasswordModifyRequestBody;
import net.lensfrex.dscape.dto.request.user.RegisterRequestBody;
import net.lensfrex.dscape.dto.response.data.user.RegisterResponseBody;
import net.lensfrex.dscape.utils.NetworkUtil;
import net.lensfrex.dscape.utils.validate.TextCheckUtil;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;

@JsonSerialize(using = ToStringSerializer.class)
@RestController
@RequestMapping("/user")
public class UserController {

    private final UserService userService;

    public UserController(UserService userService) {
        this.userService = userService;
    }

    @PostMapping(value = "/login", produces = "application/json")
    public Response<SaTokenInfo> login(@RequestBody UserLoginRequestBody requestBody) {
        if (requestBody == null
                || requestBody.getUserName() == null
                || requestBody.getPassword() == null) {

            throw new GlobalException(ResponseCode.PARAM_WRONG);
        }

        return Response.success(userService.login(requestBody));
    }

    @GetMapping(value = "/checkLogin", produces = "application/json")
    public Response<SaTokenInfo> testLogin() {
        return Response.success(userService.checkLogin());
    }

    @PostMapping(value = "/register", produces = "application/json")
    public Response<RegisterResponseBody> register(@RequestBody RegisterRequestBody request, HttpServletRequest httpServletRequest) {
        if (request.getUserName() == null || request.getPassword() == null) {
            throw new GlobalException(ResponseCode.PARAM_WRONG);
        }

        // 这里的密码也用checkNoneAbcAndChinese是因为正常从前端发来的话是sha256，实际上是可以任意符号的
        if (TextCheckUtil.checkNoneAbcAndChinese(request.getUserName(), request.getPassword())) {
            throw new GlobalException(ResponseCode.INVALID_REQUEST);
        }

        return Response.success(userService.register(request, NetworkUtil.getRealIP(httpServletRequest)));
    }

    @PostMapping(value = "/modifyPassword/{uid}", produces = "application/json")
    public Response<Object> modifyPassword(@RequestBody PasswordModifyRequestBody body, @PathVariable String uid) {
        StpUtil.checkLogin();

        userService.modifyPassword(uid, body.getOldPassword(), body.getNewPassword());

        return Response.success();
    }
}
