/*
 * Class created by lensfrex.
 */

package net.lensfrex.dscape.web.service.compute;

import cn.dev33.satoken.stp.StpUtil;
import com.github.yitter.idgen.YitIdHelper;
import net.lensfrex.dscape.configure.RabbitConfigure;
import net.lensfrex.dscape.dao.entity.ComputeHistory;
import net.lensfrex.dscape.dao.entity.PatientData;
import net.lensfrex.dscape.dao.service.ComputeHistoryService;
import net.lensfrex.dscape.dao.service.PatientDataService;
import net.lensfrex.dscape.dto.request.compute.ComputeRequestBody;
import net.lensfrex.dscape.enums.compute.ComputeStatusEnum;
import net.lensfrex.dscape.mq.MessageQueueProducer;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

@Service
public class ComputeService {
    private final PatientDataService patientDataService;

    private final ComputeHistoryService computeHistoryService;

    private final MessageQueueProducer messageQueueProducer;

    public ComputeService(PatientDataService patientDataService,
                          ComputeHistoryService computeHistoryService,
                          MessageQueueProducer messageQueueProducer) {

        this.patientDataService = patientDataService;
        this.computeHistoryService = computeHistoryService;
        this.messageQueueProducer = messageQueueProducer;
    }

    @Transactional
    public long addTask(ComputeRequestBody request) {
        long rid = YitIdHelper.nextId();
        String uid = StpUtil.getLoginIdAsString();

        ComputeHistory computeHistory = new ComputeHistory();
        computeHistory.setUid(uid);
        computeHistory.setRid(rid);
        computeHistory.setStatus(ComputeStatusEnum.PROCESSING.getCode());

        PatientData patientData = new PatientData();
        patientData.setId(rid);
        patientData.setCpg(request.getCpg());
        patientData.setPid(request.getPid());
        patientData.setCtdnaLength(request.getCtdna());

        computeHistoryService.save(computeHistory);
        patientDataService.save(patientData);

        this.addMessageQueue(patientData);

        return rid;
    }

    private void addMessageQueue(PatientData patientData) {
        messageQueueProducer.sendObject(patientData);
    }
}
