/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

package net.lensfrex.dscape.web.service.user;

import cn.dev33.satoken.stp.StpUtil;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import net.lensfrex.dscape.web.service.user.admin.InviteCode;
import net.lensfrex.dscape.cache.UserBasicCache;
import net.lensfrex.dscape.dao.entity.BlackList;
import net.lensfrex.dscape.dao.entity.UserBasic;
import net.lensfrex.dscape.dao.service.BlackListService;
import net.lensfrex.dscape.dao.service.UserBasicService;
import net.lensfrex.dscape.dto.request.user.UserAddRequest;
import net.lensfrex.dscape.dto.response.general.ResponseCode;
import net.lensfrex.dscape.enums.blacklist.BlackListTypeEnum;
import net.lensfrex.dscape.enums.user.UserRoleEnum;
import net.lensfrex.dscape.exception.GlobalException;
import net.lensfrex.dscape.dto.response.data.user.RegisterResponseBody;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class AdminService {
    private final RedisTemplate<String, String> redis;

    private final UserBasicService userBasicService;

    private final UserService userService;

    private final BlackListService blackListService;

    private final InviteCode inviteCode;

    private final UserBasicCache userBasicCache;

    public AdminService(RedisTemplate<String, String> redis,
                        UserBasicService userBasicService,
                        UserService userService,
                        BlackListService blackListService,
                        InviteCode inviteCode,
                        UserBasicCache userBasicCache) {

        this.redis = redis;
        this.userBasicService = userBasicService;
        this.userService = userService;
        this.blackListService = blackListService;
        this.inviteCode = inviteCode;
        this.userBasicCache = userBasicCache;
    }

    public List<String> generateInviteCode(long expired, int count) {
        return inviteCode.generateInviteCode(expired, count, StpUtil.getLoginIdAsString());
    }

    public void modifyUserStatus(String uid, int status) {
        UpdateWrapper<UserBasic> wrapper = new UpdateWrapper<>();
        wrapper.lambda()
                .eq(UserBasic::getUid, uid)
                .eq(UserBasic::getSuperior, StpUtil.getLoginIdAsString())
                .set(UserBasic::getStatus, status);

        this.clearUserBasicCache(uid);
        userBasicService.update(wrapper);
    }

    public void addUserToBlackList(String uid) {
        BlackList blackList = new BlackList();
        blackList.setData(uid);
        blackList.setType(BlackListTypeEnum.UID.getCode());

        blackListService.save(blackList);
    }

    public void deleteUser(String uid) {
        this.clearUserBasicCache(uid);

        userBasicService.removeById(uid);
    }

    private void clearUserBasicCache(String uid) {
        userBasicCache.clear(uid);
    }

    public RegisterResponseBody adminAddUser(UserAddRequest requestBody, String registerIp) {
        if (userService.userNameExists(requestBody.getUserName())) {
            throw new GlobalException(ResponseCode.USER_NAME_EXISTS);
        }

        String uid = userService.addUserToDatabase(requestBody.getUserName(), requestBody.getPassword(),
                StpUtil.getLoginIdAsString(), UserRoleEnum.getTypeEnumByCode(requestBody.getRole()), registerIp);

        RegisterResponseBody registerResponseBody = new RegisterResponseBody();
        registerResponseBody.setUid(uid);

        return registerResponseBody;
    }

}