/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

/*
 * Class created by lensfrex.
 */

package net.lensfrex.dscape.web.service.user.admin;

import net.lensfrex.dscape.configure.GlobalConstant;
import net.lensfrex.dscape.dto.response.general.ResponseCode;
import net.lensfrex.dscape.exception.GlobalException;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.RandomStringUtils;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

@Slf4j
@Service
public class InviteCode {
    private static final int INVITE_CODE_LENGTH = 6;

    private static final String REGISTER_INVITE_CODE_KEY = GlobalConstant.REGISTER_INVITE_CODE_KEY;

    private static final String ADMIN_INVITE_CODE_COUNTER_KEY = GlobalConstant.ADMIN_INVITE_CODE_COUNTER_KEY;

    private final RedisTemplate<String, String> redis;

    public InviteCode(RedisTemplate<String, String> redis) {
        this.redis = redis;
    }

    public List<String> generateInviteCode(long expired, int count, String adminUid) {
        String adminInviteCodeCounterKey = String.format(ADMIN_INVITE_CODE_COUNTER_KEY, adminUid);

        String countResult = redis.opsForValue().get(adminInviteCodeCounterKey);

        if (countResult != null && Integer.parseInt(countResult) > 1024) {
            throw new GlobalException(ResponseCode.INVITE_CODE_REACHED_LIMIT);
        }

        List<String> inviteCodes = new ArrayList<>(count);

        for (int i = 0; i < count; i++) {
            inviteCodes.add(RandomStringUtils.randomAlphanumeric(INVITE_CODE_LENGTH));
        }
        HashMap<String, String> codeAdmin = new HashMap<>(count);
        inviteCodes.forEach(inviteCode -> codeAdmin.put(inviteCode, adminUid));

        redis.opsForHash().putAll(REGISTER_INVITE_CODE_KEY, codeAdmin);
        redis.opsForValue().increment(adminInviteCodeCounterKey, count);

        return inviteCodes;
    }

    public boolean checkInviteCode(String code) {
        try {
            return redis.opsForHash().get(REGISTER_INVITE_CODE_KEY, code) == null;
        } catch (Exception e) {
            return false;
        }
    }

    public String useInviteCode(String code) {
        try {
            String superior = (String) redis.opsForHash().get(REGISTER_INVITE_CODE_KEY, code);
            if (superior == null) {
                throw new GlobalException(ResponseCode.INVITE_CODE_WRONG);
            }

            redis.opsForHash().delete(REGISTER_INVITE_CODE_KEY, code);
            redis.opsForValue().decrement(String.format(ADMIN_INVITE_CODE_COUNTER_KEY, superior));

            return superior;
        } catch (Exception e) {
            throw new GlobalException(ResponseCode.INVITE_CODE_WRONG);
        }
    }
}
